jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Alex Light | ea1e770 | 2016-07-11 13:39:55 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Alan Leung | cf2de16 | 2018-03-30 20:18:20 +0000 | [diff] [blame] | 48 | export USE_D8="true" |
Colin Cross | e0ef0a8 | 2017-07-27 21:29:18 +0000 | [diff] [blame] | 49 | export USE_JACK="false" |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 50 | export USE_DESUGAR="true" |
Ben Gruver | 14fc9db | 2017-04-28 15:30:49 -0700 | [diff] [blame] | 51 | export SMALI_ARGS="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 52 | |
Alan Leung | d5cbc56 | 2018-03-15 14:02:46 -0700 | [diff] [blame] | 53 | # If d8 was not set by the environment variable, assume it is in the path. |
| 54 | if [ -z "$D8" ]; then |
| 55 | export D8="d8" |
| 56 | fi |
| 57 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 58 | # If dx was not set by the environment variable, assume it is in the path. |
| 59 | if [ -z "$DX" ]; then |
| 60 | export DX="dx" |
| 61 | fi |
| 62 | |
Alan Leung | d5cbc56 | 2018-03-15 14:02:46 -0700 | [diff] [blame] | 63 | export DXMERGER="$D8" |
| 64 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 65 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 66 | if [ -z "$JASMIN" ]; then |
| 67 | export JASMIN="jasmin" |
| 68 | fi |
| 69 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 70 | # If smali was not set by the environment variable, assume it is in the path. |
| 71 | if [ -z "$SMALI" ]; then |
| 72 | export SMALI="smali" |
| 73 | fi |
| 74 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 75 | # If jack was not set by the environment variable, assume it is in the path. |
| 76 | if [ -z "$JACK" ]; then |
| 77 | export JACK="jack" |
| 78 | fi |
| 79 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 80 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 81 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 82 | export ANDROID_BUILD_TOP=$oldwd |
| 83 | fi |
| 84 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 85 | # ANDROID_HOST_OUT is not set in a build environment. |
| 86 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Dan Willemsen | f325e01 | 2017-03-03 12:35:30 -0800 | [diff] [blame] | 87 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86 |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 88 | fi |
| 89 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 90 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 91 | if [ -z "$JACK_CLASSPATH" ]; then |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 92 | export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 93 | fi |
| 94 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 95 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 96 | |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 97 | # Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false. |
Igor Murashkin | d323277 | 2017-06-22 14:54:13 -0700 | [diff] [blame] | 98 | if [ -z "$DESUGAR" ]; then |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 99 | export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh" |
| 100 | fi |
| 101 | |
Igor Murashkin | 271a0f8 | 2017-02-14 21:14:17 +0000 | [diff] [blame] | 102 | # Zipalign is not on the PATH in some configs, auto-detect it. |
| 103 | if [ -z "$ZIPALIGN" ]; then |
| 104 | if which zipalign >/dev/null; then |
| 105 | ZIPALIGN="zipalign"; |
| 106 | else |
| 107 | # TODO: Add a dependency for zipalign in Android.run-test.mk |
| 108 | # once it doesn't depend on libandroidfw (b/35246701) |
| 109 | case "$OSTYPE" in |
| 110 | darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;; |
| 111 | linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;; |
| 112 | *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;; |
| 113 | esac |
| 114 | fi |
| 115 | fi |
| 116 | export ZIPALIGN |
| 117 | |
David Brazdil | 122c663 | 2018-01-24 17:32:49 +0000 | [diff] [blame] | 118 | # If hiddenapi was not set by the environment variable, assume it is in |
| 119 | # ANDROID_HOST_OUT. |
David Brazdil | 11b67b2 | 2018-01-18 16:41:40 +0000 | [diff] [blame] | 120 | if [ -z "$HIDDENAPI" ]; then |
David Brazdil | 122c663 | 2018-01-24 17:32:49 +0000 | [diff] [blame] | 121 | export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi" |
David Brazdil | 11b67b2 | 2018-01-18 16:41:40 +0000 | [diff] [blame] | 122 | fi |
| 123 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 124 | info="info.txt" |
| 125 | build="build" |
| 126 | run="run" |
| 127 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 128 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 129 | output="output.txt" |
| 130 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 131 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 132 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 133 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 134 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 135 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 136 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 137 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 138 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 139 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 140 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 141 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 142 | dev_mode="no" |
| 143 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 144 | debug_mode="no" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 145 | relocate="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 146 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 147 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 148 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 149 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 150 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 151 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 152 | basic_verify="false" |
| 153 | gc_verify="false" |
| 154 | gc_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 155 | jvmti_trace_stress="false" |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 156 | jvmti_field_stress="false" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 157 | jvmti_step_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 158 | jvmti_redefine_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 159 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 160 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 161 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 162 | have_dex2oat="yes" |
| 163 | have_patchoat="yes" |
| 164 | have_image="yes" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 165 | multi_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 166 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 167 | bisection_search="no" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 168 | suspend_timeout="500000" |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 169 | # By default we will use optimizing. |
| 170 | image_args="" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 171 | image_suffix="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 172 | |
| 173 | while true; do |
| 174 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 175 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 176 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 177 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 178 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 179 | elif [ "x$1" = "x--quiet" ]; then |
| 180 | quiet="yes" |
| 181 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 182 | elif [ "x$1" = "x--use-java-home" ]; then |
| 183 | if [ -n "${JAVA_HOME}" ]; then |
| 184 | export JAVA="${JAVA_HOME}/bin/java" |
| 185 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 186 | else |
| 187 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 188 | usage="yes" |
| 189 | fi |
| 190 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 191 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 192 | target_mode="no" |
Alex Light | 2c7aaeb | 2017-01-27 14:08:17 -0800 | [diff] [blame] | 193 | DEX_LOCATION="$tmp_dir" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 194 | runtime="jvm" |
Alex Light | bc90d0f | 2016-05-09 16:21:09 -0700 | [diff] [blame] | 195 | image_args="" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 196 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 197 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 198 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 199 | run_args="${run_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 200 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 201 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 202 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 203 | testlib="arttest" |
Alex Light | faf90b6 | 2016-08-12 14:43:48 -0700 | [diff] [blame] | 204 | run_args="${run_args} -O" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 205 | shift |
| 206 | elif [ "x$1" = "x--dalvik" ]; then |
| 207 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 208 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 209 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 210 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 211 | have_dex2oat="no" |
| 212 | shift |
| 213 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 214 | have_patchoat="no" |
| 215 | shift |
| 216 | elif [ "x$1" = "x--no-image" ]; then |
| 217 | have_image="no" |
| 218 | shift |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 219 | elif [ "x$1" = "x--multi-image" ]; then |
| 220 | multi_image_suffix="-multi" |
| 221 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 222 | elif [ "x$1" = "x--pic-test" ]; then |
| 223 | run_args="${run_args} --pic-test" |
| 224 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 225 | elif [ "x$1" = "x--relocate" ]; then |
| 226 | relocate="yes" |
| 227 | shift |
| 228 | elif [ "x$1" = "x--no-relocate" ]; then |
| 229 | relocate="no" |
| 230 | shift |
| 231 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 232 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 233 | prebuild_mode="yes" |
| 234 | shift; |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 235 | elif [ "x$1" = "x--compact-dex-level" ]; then |
| 236 | option="$1" |
| 237 | shift |
| 238 | run_args="${run_args} $option $1" |
| 239 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 240 | elif [ "x$1" = "x--strip-dex" ]; then |
| 241 | run_args="${run_args} --strip-dex" |
| 242 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 243 | elif [ "x$1" = "x--debuggable" ]; then |
| 244 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 245 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 246 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 247 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 248 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 249 | prebuild_mode="no" |
| 250 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 251 | elif [ "x$1" = "x--gcverify" ]; then |
| 252 | basic_verify="true" |
| 253 | gc_verify="true" |
| 254 | shift |
| 255 | elif [ "x$1" = "x--gcstress" ]; then |
| 256 | basic_verify="true" |
| 257 | gc_stress="true" |
| 258 | shift |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 259 | elif [ "x$1" = "x--jvmti-step-stress" ]; then |
| 260 | jvmti_step_stress="true" |
| 261 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 262 | elif [ "x$1" = "x--jvmti-redefine-stress" ]; then |
| 263 | jvmti_redefine_stress="true" |
| 264 | shift |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 265 | elif [ "x$1" = "x--jvmti-field-stress" ]; then |
| 266 | jvmti_field_stress="true" |
| 267 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 268 | elif [ "x$1" = "x--jvmti-trace-stress" ]; then |
| 269 | jvmti_trace_stress="true" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 270 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 271 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 272 | shift |
| 273 | suspend_timeout="$1" |
| 274 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 275 | elif [ "x$1" = "x--image" ]; then |
| 276 | shift |
| 277 | image="$1" |
| 278 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 279 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 280 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 281 | shift |
| 282 | option="$1" |
| 283 | run_args="${run_args} -Xcompiler-option $option" |
| 284 | shift |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 285 | elif [ "x$1" = "x--build-option" ]; then |
| 286 | shift |
| 287 | option="$1" |
| 288 | build_args="${build_args} $option" |
| 289 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 290 | elif [ "x$1" = "x--runtime-option" ]; then |
| 291 | shift |
| 292 | option="$1" |
| 293 | run_args="${run_args} --runtime-option $option" |
| 294 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 295 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 296 | shift |
| 297 | gdb_arg="$1" |
| 298 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 299 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 300 | elif [ "x$1" = "x--debug" ]; then |
| 301 | run_args="${run_args} --debug" |
| 302 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 303 | elif [ "x$1" = "x--debug-wrap-agent" ]; then |
| 304 | run_args="${run_args} --debug-wrap-agent" |
| 305 | shift |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 306 | elif [ "x$1" = "x--with-agent" ]; then |
| 307 | shift |
| 308 | option="$1" |
| 309 | run_args="${run_args} --with-agent $1" |
| 310 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 311 | elif [ "x$1" = "x--debug-agent" ]; then |
| 312 | shift |
| 313 | option="$1" |
| 314 | run_args="${run_args} --debug-agent $1" |
| 315 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 316 | elif [ "x$1" = "x--gdb" ]; then |
| 317 | run_args="${run_args} --gdb" |
| 318 | dev_mode="yes" |
| 319 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 320 | elif [ "x$1" = "x--strace" ]; then |
| 321 | strace="yes" |
Mathieu Chartier | 2576be2 | 2016-05-24 10:24:53 -0700 | [diff] [blame] | 322 | run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 323 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 324 | elif [ "x$1" = "x--zygote" ]; then |
| 325 | run_args="${run_args} --zygote" |
| 326 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 327 | elif [ "x$1" = "x--interpreter" ]; then |
Nicolas Geoffray | 4650c93 | 2016-05-10 09:13:13 +0000 | [diff] [blame] | 328 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 329 | image_suffix="-interpreter" |
| 330 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 331 | elif [ "x$1" = "x--jit" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 332 | image_args="--jit" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 333 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 334 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 335 | elif [ "x$1" = "x--optimizing" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 336 | image_args="-Xcompiler-option --compiler-backend=Optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 337 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 338 | elif [ "x$1" = "x--no-verify" ]; then |
Richard Uhler | f4b3487 | 2016-04-13 11:03:46 -0700 | [diff] [blame] | 339 | run_args="${run_args} --no-verify" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 340 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 341 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 342 | image_args="--verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 343 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 344 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 345 | elif [ "x$1" = "x--no-optimize" ]; then |
| 346 | run_args="${run_args} --no-optimize" |
| 347 | shift |
| 348 | elif [ "x$1" = "x--no-precise" ]; then |
| 349 | run_args="${run_args} --no-precise" |
| 350 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 351 | elif [ "x$1" = "x--invoke-with" ]; then |
| 352 | shift |
| 353 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 354 | if [ "x$what" = "x" ]; then |
| 355 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 356 | usage="yes" |
| 357 | break |
| 358 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 359 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 360 | shift |
| 361 | elif [ "x$1" = "x--dev" ]; then |
| 362 | run_args="${run_args} --dev" |
| 363 | dev_mode="yes" |
| 364 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 365 | elif [ "x$1" = "x--build-only" ]; then |
| 366 | build_only="yes" |
| 367 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 368 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 369 | USE_JACK="false" |
| 370 | shift |
| 371 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 372 | USE_JACK="true" |
| 373 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 374 | elif [ "x$1" = "x--output-path" ]; then |
| 375 | shift |
| 376 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 377 | if [ "x$tmp_dir" = "x" ]; then |
| 378 | echo "$0 missing argument to --output-path" 1>&2 |
| 379 | usage="yes" |
| 380 | break |
| 381 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 382 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 383 | elif [ "x$1" = "x--android-root" ]; then |
| 384 | shift |
| 385 | if [ "x$1" = "x" ]; then |
| 386 | echo "$0 missing argument to --android-root" 1>&2 |
| 387 | usage="yes" |
| 388 | break |
| 389 | fi |
| 390 | android_root="$1" |
| 391 | run_args="${run_args} --android-root $1" |
| 392 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 393 | elif [ "x$1" = "x--update" ]; then |
| 394 | update_mode="yes" |
| 395 | shift |
| 396 | elif [ "x$1" = "x--help" ]; then |
| 397 | usage="yes" |
| 398 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 399 | elif [ "x$1" = "x--64" ]; then |
| 400 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 401 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 402 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 403 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 404 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 405 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 406 | elif [ "x$1" = "x--stream" ]; then |
| 407 | trace_stream="true" |
| 408 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 409 | elif [ "x$1" = "x--always-clean" ]; then |
| 410 | always_clean="yes" |
| 411 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 412 | elif [ "x$1" = "x--never-clean" ]; then |
| 413 | never_clean="yes" |
| 414 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 415 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 416 | run_args="${run_args} --dex2oat-swap" |
| 417 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 418 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 419 | shift |
| 420 | run_args="${run_args} --instruction-set-features $1" |
| 421 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 422 | elif [ "x$1" = "x--bisection-search" ]; then |
| 423 | bisection_search="yes" |
| 424 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 425 | elif [ "x$1" = "x--vdex" ]; then |
| 426 | run_args="${run_args} --vdex" |
| 427 | shift |
Nicolas Geoffray | baeaa9b | 2018-01-26 14:31:17 +0000 | [diff] [blame] | 428 | elif [ "x$1" = "x--dm" ]; then |
| 429 | run_args="${run_args} --dm" |
| 430 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 431 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 432 | shift |
| 433 | filter=$1 |
| 434 | run_args="${run_args} --vdex-filter $filter" |
| 435 | shift |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 436 | elif [ "x$1" = "x--random-profile" ]; then |
| 437 | run_args="${run_args} --random-profile" |
| 438 | shift |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 439 | elif [ "x$1" = "x--dex2oat-jobs" ]; then |
| 440 | shift |
| 441 | run_args="${run_args} -Xcompiler-option -j$1" |
| 442 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 443 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 444 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 445 | usage="yes" |
| 446 | break |
| 447 | else |
| 448 | break |
| 449 | fi |
| 450 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 451 | |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 452 | run_args="${run_args} ${image_args}" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 453 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 454 | # output (fd 2). |
| 455 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 456 | exec {real_stderr}>&2 |
| 457 | else |
| 458 | # In bash before version 4.1 we need to do a manual search for free file |
| 459 | # descriptors. |
| 460 | FD=3 |
| 461 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 462 | real_stderr=$FD |
| 463 | eval "exec ${real_stderr}>&2" |
| 464 | fi |
| 465 | if [ "$quiet" = "yes" ]; then |
| 466 | # Force the default standard output and error to go to /dev/null so we will |
| 467 | # not print them. |
| 468 | exec 1>/dev/null |
| 469 | exec 2>/dev/null |
| 470 | fi |
| 471 | |
| 472 | function err_echo() { |
| 473 | echo "$@" 1>&${real_stderr} |
| 474 | } |
| 475 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 476 | # tmp_dir may be relative, resolve. |
| 477 | # |
| 478 | # Cannot use realpath, as it does not exist on Mac. |
| 479 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 480 | # Cannot use readlink -m, as it does not exist on Mac. |
| 481 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 482 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 483 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 484 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 485 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 486 | # Add thread suspend timeout flag |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 487 | if [ ! "$runtime" = "jvm" ]; then |
| 488 | run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout" |
| 489 | fi |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 490 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 491 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 492 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 493 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 494 | fi |
| 495 | if [ "$gc_verify" = "true" ]; then |
| 496 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 497 | fi |
| 498 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | d9eb284 | 2016-08-12 16:11:24 -0700 | [diff] [blame] | 499 | run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 500 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 501 | if [ "$jvmti_redefine_stress" = "true" ]; then |
| 502 | run_args="${run_args} --no-app-image --jvmti-redefine-stress" |
| 503 | fi |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 504 | if [ "$jvmti_step_stress" = "true" ]; then |
| 505 | run_args="${run_args} --no-app-image --jvmti-step-stress" |
| 506 | fi |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 507 | if [ "$jvmti_field_stress" = "true" ]; then |
| 508 | run_args="${run_args} --no-app-image --jvmti-field-stress" |
| 509 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 510 | if [ "$jvmti_trace_stress" = "true" ]; then |
| 511 | run_args="${run_args} --no-app-image --jvmti-trace-stress" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 512 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 513 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 514 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 515 | if [ "$trace_stream" = "true" ]; then |
| 516 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 517 | # the ability to analyze the file and just write to /dev/null. |
| 518 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 519 | # Enable streaming mode. |
| 520 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 521 | else |
| 522 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 523 | fi |
| 524 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 525 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 526 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 527 | fi |
| 528 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 529 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 93d6846 | 2018-01-02 11:59:45 +0000 | [diff] [blame] | 530 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 531 | function guess_target_arch_name() { |
Nicolas Geoffray | 93d6846 | 2018-01-02 11:59:45 +0000 | [diff] [blame] | 532 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
| 533 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 534 | if [ "x${suffix64}" = "x64" ]; then |
| 535 | target_arch_name=${grep64bit} |
| 536 | else |
| 537 | target_arch_name=${grep32bit} |
| 538 | fi |
| 539 | } |
| 540 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 541 | function guess_host_arch_name() { |
| 542 | if [ "x${suffix64}" = "x64" ]; then |
| 543 | host_arch_name="x86_64" |
| 544 | else |
| 545 | host_arch_name="x86" |
| 546 | fi |
| 547 | } |
| 548 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 549 | if [ "$target_mode" = "no" ]; then |
| 550 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 551 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 552 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 553 | exit 1; |
| 554 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 555 | fi |
| 556 | fi |
| 557 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 558 | if [ "$have_patchoat" = "no" ]; then |
| 559 | run_args="${run_args} --no-patchoat" |
| 560 | fi |
| 561 | |
| 562 | if [ "$have_dex2oat" = "no" ]; then |
| 563 | run_args="${run_args} --no-dex2oat" |
| 564 | fi |
| 565 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 566 | if [ ! "$runtime" = "jvm" ]; then |
| 567 | run_args="${run_args} --lib $lib" |
| 568 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 569 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 570 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 571 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 93d6846 | 2018-01-02 11:59:45 +0000 | [diff] [blame] | 572 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Andreas Gampe | 50be66f | 2015-12-28 14:31:06 -0800 | [diff] [blame] | 573 | bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 574 | run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 575 | else |
| 576 | true # defaults to using target BOOTCLASSPATH |
| 577 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 578 | elif [ "$runtime" = "art" ]; then |
| 579 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 580 | guess_host_arch_name |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 581 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art" |
Colin Cross | afd3c9e | 2016-09-16 13:47:21 -0700 | [diff] [blame] | 582 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 583 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 584 | guess_target_arch_name |
Dimitry Ivanov | 49c2c92 | 2017-02-14 11:06:14 -0800 | [diff] [blame] | 585 | run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}" |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 586 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 587 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 588 | if [ "$relocate" = "yes" ]; then |
| 589 | run_args="${run_args} --relocate" |
| 590 | else |
| 591 | run_args="${run_args} --no-relocate" |
| 592 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 593 | elif [ "$runtime" = "jvm" ]; then |
| 594 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Alex Light | fba89fe | 2017-01-12 16:11:02 -0800 | [diff] [blame] | 595 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 596 | fi |
| 597 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 598 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 599 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 600 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 601 | exit 1 |
| 602 | fi |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 603 | run_args="${run_args} --no-image" |
| 604 | fi |
| 605 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 606 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 607 | err_echo "--dev and --update are mutually exclusive" |
| 608 | usage="yes" |
| 609 | fi |
| 610 | |
| 611 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 612 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 613 | usage="yes" |
| 614 | fi |
| 615 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 616 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 617 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 618 | usage="yes" |
| 619 | fi |
| 620 | |
| 621 | if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then |
| 622 | err_echo "--bisection-search and --no-dex2oat are mutually exclusive" |
| 623 | usage="yes" |
| 624 | fi |
| 625 | |
| 626 | if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then |
| 627 | err_echo "--bisection-search and --no-patchoat are mutually exclusive" |
| 628 | usage="yes" |
| 629 | fi |
| 630 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 631 | if [ "$usage" = "no" ]; then |
| 632 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 633 | test_dir=`basename "$oldwd"` |
| 634 | else |
| 635 | test_dir="$1" |
| 636 | fi |
| 637 | |
| 638 | if [ '!' -d "$test_dir" ]; then |
| 639 | td2=`echo ${test_dir}-*` |
| 640 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 641 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 642 | usage="yes" |
| 643 | fi |
| 644 | test_dir="$td2" |
| 645 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 646 | # Shift to get rid of the test name argument. The rest of the arguments |
| 647 | # will get passed to the test run. |
| 648 | shift |
| 649 | fi |
| 650 | |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 651 | # For building with javac and dx always use Java 7. The dx compiler |
| 652 | # only support byte codes from Java 7 or earlier (class file major |
| 653 | # version 51 or lower). |
| 654 | if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then |
| 655 | export JAVAC="${JAVAC} -source 1.7 -target 1.7" |
| 656 | fi |
| 657 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 658 | if [ "$usage" = "yes" ]; then |
| 659 | prog=`basename $prog` |
| 660 | ( |
| 661 | echo "usage:" |
| 662 | echo " $prog --help Print this message." |
| 663 | echo " $prog [options] [test-name] Run test normally." |
| 664 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 665 | "(dumps to stdout)." |
| 666 | echo " $prog --update [options] [test-name] Update mode" \ |
| 667 | "(replaces expected.txt)." |
| 668 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 669 | "current directory." |
| 670 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 671 | echo " -O Run non-debug rather than debug build (off by default)." |
| 672 | echo " -Xcompiler-option Pass an option to the compiler." |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 673 | echo " --build-option Pass an option to the build script." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 674 | echo " --runtime-option Pass an option to the runtime." |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 675 | echo " --compact-dex-level Specify a compact dex level to the compiler." |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 676 | echo " --debug Wait for the default debugger to attach." |
| 677 | echo " --debug-agent <agent-path>" |
| 678 | echo " Wait for the given debugger agent to attach. Currently" |
| 679 | echo " only supported on host." |
| 680 | echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props" |
| 681 | echo " to load the debugger agent specified by --debug-agent." |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 682 | echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 683 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 684 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 685 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 686 | echo " --build-only Build test files only (off by default)." |
Alan Leung | 0afa07a | 2017-10-03 16:56:30 -0700 | [diff] [blame] | 687 | echo " --build-with-d8 Build test files with javac and d8 (off by default)." |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 688 | echo " --build-with-javac-dx Build test files with javac and dx (off by default)." |
| 689 | echo " --build-with-jack Build test files with jack and jill (on by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 690 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 691 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 692 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 693 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 694 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 695 | echo " Verification is enabled if neither --no-verify" |
| 696 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 697 | echo " --no-optimize Turn off optimization (on by default)." |
| 698 | echo " --no-precise Turn off precise GC (on by default)." |
| 699 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 700 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 701 | echo " other runtime options are ignored." |
| 702 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 703 | echo " --no-patchoat Run as though patchoat was failing." |
| 704 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 705 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 706 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 707 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 708 | echo " --relocate Force the use of relocating in the test, making" |
| 709 | echo " the image and oat files be relocated to a random" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 710 | echo " address before running." |
| 711 | echo " --no-relocate Force the use of no relocating in the test. (default)" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 712 | echo " --image Run the test using a precompiled boot image. (default)" |
| 713 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 714 | echo " --host Use the host-mode virtual machine." |
| 715 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 716 | echo " --dalvik Use Dalvik (off by default)." |
| 717 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 718 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 719 | echo " to find the java compiler and runtime" |
| 720 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 721 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 722 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 723 | echo " --64 Run the test in 64-bit mode" |
| 724 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 725 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 726 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 727 | echo " --gcstress Run with gc stress testing" |
| 728 | echo " --gcverify Run with gc verification" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 729 | echo " --jvmti-trace-stress Run with jvmti method tracing stress testing" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 730 | echo " --jvmti-step-stress Run with jvmti single step stress testing" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 731 | echo " --jvmti-redefine-stress" |
| 732 | echo " Run with jvmti method redefinition stress testing" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 733 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 734 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 735 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 736 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 737 | echo " --instruction-set-features [string]" |
| 738 | echo " Set instruction-set-features for compilation." |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 739 | echo " --multi-image Use a set of images compiled with dex2oat multi-image for" |
| 740 | echo " the boot class path." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 741 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 742 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 743 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 744 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 745 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 746 | echo " --dex2oat-jobs Number of dex2oat jobs." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 747 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 748 | exit 1 |
| 749 | fi |
| 750 | |
| 751 | cd "$test_dir" |
| 752 | test_dir=`pwd` |
| 753 | |
| 754 | td_info="${test_dir}/${info}" |
| 755 | td_expected="${test_dir}/${expected}" |
| 756 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 757 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 758 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 759 | exit 1 |
| 760 | fi |
| 761 | |
| 762 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 763 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 764 | exit 1 |
| 765 | fi |
| 766 | |
| 767 | # copy the test to a temp dir and run it |
| 768 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 769 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 770 | |
| 771 | rm -rf "$tmp_dir" |
| 772 | cp -Rp "$test_dir" "$tmp_dir" |
| 773 | cd "$tmp_dir" |
| 774 | |
| 775 | if [ '!' -r "$build" ]; then |
| 776 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 777 | else |
| 778 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 779 | fi |
| 780 | |
| 781 | if [ '!' -r "$run" ]; then |
| 782 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 783 | else |
| 784 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 785 | fi |
| 786 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 787 | if [ '!' -r "$check_cmd" ]; then |
| 788 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 789 | else |
| 790 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 791 | fi |
| 792 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 793 | chmod 755 "$build" |
| 794 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 795 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 796 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 797 | export TEST_NAME=`basename ${test_dir}` |
| 798 | |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 799 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 800 | # Checker when compiled with Optimizing on host. |
| 801 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 802 | if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then |
| 803 | # In no-prebuild or no-image mode, the compiler only quickens so disable the checker. |
| 804 | if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then |
| 805 | run_checker="yes" |
| 806 | |
| 807 | if [ "$target_mode" = "no" ]; then |
| 808 | cfg_output_dir="$tmp_dir" |
| 809 | checker_args="--arch=${host_arch_name^^}" |
| 810 | else |
| 811 | cfg_output_dir="$DEX_LOCATION" |
| 812 | checker_args="--arch=${target_arch_name^^}" |
| 813 | fi |
| 814 | |
| 815 | if [ "$debuggable" = "yes" ]; then |
| 816 | checker_args="$checker_args --debuggable" |
| 817 | fi |
| 818 | |
| 819 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
| 820 | -Xcompiler-option -j1" |
| 821 | fi |
| 822 | fi |
| 823 | fi |
| 824 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 825 | run_args="${run_args} --testlib ${testlib}" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 826 | |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 827 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and |
| 828 | # ART output to approximately 128MB. This should be more than sufficient |
| 829 | # for any test while still catching cases of runaway output. |
| 830 | # Set a hard limit to encourage ART developers to increase the ulimit here if |
| 831 | # needed to support a test case rather than resetting the limit in the run |
| 832 | # script for the particular test in question. |
Orion Hodson | bd328d3 | 2017-03-24 11:24:10 +0000 | [diff] [blame] | 833 | if ! ulimit -f 128000; then |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 834 | err_echo "ulimit file size setting failed" |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 835 | fi |
| 836 | |
Igor Murashkin | 2de6e08 | 2018-02-28 15:25:23 -0800 | [diff] [blame] | 837 | # Tell the build script which mode (target, host, jvm) we are building for |
| 838 | # to determine the bootclasspath at build time. |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 839 | if [[ "$target_mode" == "yes" ]]; then |
| 840 | build_args="$build_args --target" |
| 841 | else |
Igor Murashkin | 2de6e08 | 2018-02-28 15:25:23 -0800 | [diff] [blame] | 842 | if [[ $runtime == "jvm" ]]; then |
| 843 | build_args="$build_args --jvm" |
| 844 | else |
| 845 | build_args="$build_args --host" |
| 846 | fi |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 847 | fi |
| 848 | |
| 849 | if [[ "$dev_mode" == "yes" ]]; then |
| 850 | build_args="$build_args --dev" |
| 851 | fi |
| 852 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 853 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 854 | good_build="yes" |
| 855 | good_run="yes" |
Alex Light | 77fee87 | 2017-09-05 14:51:49 -0700 | [diff] [blame] | 856 | export TEST_RUNTIME="${runtime}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 857 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 858 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 859 | build_exit="$?" |
| 860 | echo "build exit status: $build_exit" 1>&2 |
| 861 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 862 | echo "${test_dir}: running..." 1>&2 |
| 863 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 864 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 865 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 866 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 867 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 868 | if [ "$target_mode" = "yes" ]; then |
| 869 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 870 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 871 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 872 | checker_exit="$?" |
| 873 | if [ "$checker_exit" = "0" ]; then |
| 874 | good="yes" |
| 875 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 876 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 877 | else |
| 878 | good="yes" |
| 879 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 880 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 881 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 882 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 883 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 884 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 885 | build_exit="$?" |
| 886 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 887 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 888 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 889 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 890 | if [ "$target_mode" = "yes" ]; then |
| 891 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 892 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 893 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 894 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 895 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 896 | good="yes" |
| 897 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 898 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 899 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 900 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 901 | elif [ "$build_only" = "yes" ]; then |
| 902 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 903 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 904 | build_exit="$?" |
| 905 | if [ "$build_exit" '!=' '0' ]; then |
| 906 | cp "$build_output" "$output" |
| 907 | echo "build exit status: $build_exit" >>"$output" |
| 908 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 909 | if [ "$?" '!=' "0" ]; then |
| 910 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 911 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 912 | fi |
| 913 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 914 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 915 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 916 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 917 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 918 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 919 | build_exit="$?" |
| 920 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 921 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 922 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 923 | run_exit="$?" |
| 924 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 925 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 926 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 927 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 928 | if [ "$target_mode" = "yes" ]; then |
| 929 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 930 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 931 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 932 | checker_exit="$?" |
| 933 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 934 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 935 | good_run="no" |
| 936 | else |
| 937 | good_run="yes" |
| 938 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 939 | else |
| 940 | good_run="yes" |
| 941 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 942 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 943 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 944 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 945 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 946 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 947 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 948 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 949 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 950 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 951 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 952 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 953 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 954 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 955 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 956 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 957 | # output == expected |
| 958 | good="yes" |
| 959 | echo "${test_dir}: succeeded!" 1>&2 |
| 960 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 961 | fi |
| 962 | fi |
| 963 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 964 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 965 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 966 | echo "${test_dir}: FAILED!" |
| 967 | echo ' ' |
| 968 | echo '#################### info' |
| 969 | cat "${td_info}" | sed 's/^/# /g' |
| 970 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 971 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 972 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 973 | if [ "$strace" = "yes" ]; then |
| 974 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 975 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 976 | echo '####################' |
| 977 | fi |
Andreas Gampe | e79ca19 | 2017-07-31 10:30:16 -0700 | [diff] [blame] | 978 | if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then |
| 979 | # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The |
| 980 | # tools used by the given ABI work for both x86 and x86-64. |
| 981 | echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000 |
| 982 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 983 | echo ' ' |
| 984 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 985 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 986 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 987 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 988 | # Attempt bisection only if the test failed. |
| 989 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 990 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 991 | if [ "$run_checker" == "yes" ]; then |
| 992 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 993 | else |
| 994 | # Increase file size limit, bisection search can generate large logfiles. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 995 | echo "${test_dir}: bisecting..." 1>&2 |
| 996 | cwd=`pwd` |
| 997 | maybe_device_mode="" |
| 998 | raw_cmd="" |
| 999 | if [ "$target_mode" = "yes" ]; then |
| 1000 | # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option |
| 1001 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 1002 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 1003 | # for bisection search to correctly retrieve logs from device. |
| 1004 | "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
| 1005 | adb shell chmod u+x "$DEX_LOCATION/cmdline.sh" |
| 1006 | maybe_device_mode="--device" |
| 1007 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 1008 | else |
| 1009 | raw_cmd="$cwd/${run} --external-log-tags $run_args $@" |
| 1010 | fi |
| 1011 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 1012 | $maybe_device_mode \ |
| 1013 | --raw-cmd="$raw_cmd" \ |
| 1014 | --check-script="$cwd/check" \ |
| 1015 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 1016 | --logfile="$cwd/bisection_log.txt" \ |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1017 | --timeout=300 |
| 1018 | fi |
| 1019 | fi |
| 1020 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1021 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 1022 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1023 | cd "$oldwd" |
| 1024 | rm -rf "$tmp_dir" |
| 1025 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 1026 | adb shell rm -rf $DEX_LOCATION |
| 1027 | fi |
| 1028 | if [ "$good" = "yes" ]; then |
| 1029 | exit 0 |
| 1030 | fi |
| 1031 | fi |
| 1032 | |
| 1033 | |
| 1034 | ( |
| 1035 | if [ "$always_clean" = "yes" ]; then |
| 1036 | echo "${TEST_NAME} files deleted from host " |
| 1037 | if [ "$target_mode" == "yes" ]; then |
| 1038 | echo "and from target" |
| 1039 | fi |
| 1040 | else |
| 1041 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 1042 | if [ "$target_mode" == "yes" ]; then |
| 1043 | echo "and in ${DEX_LOCATION} on target" |
| 1044 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 1045 | fi |
| 1046 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1047 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1048 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 1049 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 1050 | exit 0 |
| 1051 | else |
| 1052 | exit 1 |
| 1053 | fi |